/**
 * <copyright>
 * </copyright>
 *
 * $Id: AdditiveOp.java 9011 2012-01-13 14:48:10Z mjohannes $
 */
package org.openxma.dsl.core.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Additive Op</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.openxma.dsl.core.CorePackage#getAdditiveOp()
 * @model
 * @generated
 */
public enum AdditiveOp implements Enumerator {
	/**
     * The '<em><b>NULL</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #NULL_VALUE
     * @generated
     * @ordered
     */
	NULL(0, "NULL", "NULL"), /**
     * The '<em><b>PLUS</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #PLUS_VALUE
     * @generated
     * @ordered
     */
	PLUS(1, "PLUS", "+"),

	/**
     * The '<em><b>MINUS</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #MINUS_VALUE
     * @generated
     * @ordered
     */
	MINUS(2, "MINUS", "-");

	/**
     * The '<em><b>NULL</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>NULL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #NULL
     * @model
     * @generated
     * @ordered
     */
	public static final int NULL_VALUE = 0;

	/**
     * The '<em><b>PLUS</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>PLUS</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #PLUS
     * @model literal="+"
     * @generated
     * @ordered
     */
	public static final int PLUS_VALUE = 1;

	/**
     * The '<em><b>MINUS</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>MINUS</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #MINUS
     * @model literal="-"
     * @generated
     * @ordered
     */
	public static final int MINUS_VALUE = 2;

	/**
     * An array of all the '<em><b>Additive Op</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static final AdditiveOp[] VALUES_ARRAY =
		new AdditiveOp[] {
            NULL,
            PLUS,
            MINUS,
        };

	/**
     * A public read-only list of all the '<em><b>Additive Op</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final List<AdditiveOp> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
     * Returns the '<em><b>Additive Op</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static AdditiveOp get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            AdditiveOp result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Additive Op</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static AdditiveOp getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            AdditiveOp result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Additive Op</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static AdditiveOp get(int value) {
        switch (value) {
            case NULL_VALUE: return NULL;
            case PLUS_VALUE: return PLUS;
            case MINUS_VALUE: return MINUS;
        }
        return null;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final int value;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String name;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String literal;

	/**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private AdditiveOp(int value, String name, String literal) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getValue() {
      return value;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
      return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getLiteral() {
      return literal;
    }

	/**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        return literal;
    }
	
} //AdditiveOp
